import 'package:flutter/cupertino.dart';
import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_database/models/enums/nui_database_operator.dart';
import 'package:nui_database/models/enums/nui_database_query_type.dart';
import 'package:nui_database/models/nui_database_entity_field.dart';
import 'package:nui_database/models/nui_database_query.dart';
import 'package:nui_database/models/nui_database_query_interf.dart';

typedef InnerLevelQuery = NUIDBQueryCombination Function(NUIDBQueryCombination query);

class NUIDBQueryCombination implements NUIDBQueryInterf{
  NUIDBQueryCombination({@required this.queries, this.operator:NUIDBQueryOperator.AND});
  NUIDBQueryOperator operator;
  List<NUIDBQueryInterf> queries;

  String query(List<dynamic> params){
    String query = "";
    for(NUIDBQueryInterf q in this.queries){
      if(query.isEmpty){
        query = query + q.query(params);
      }
      else{
        query = query + " ${operator.value()} " + q.query(params);
      }
    }
    return "($query)";
  }

  NUIDBQueryCombination where({@required String field, @required NUIEntType type, @required NUIDBQueryType condition, @required dynamic value}){
    queries.add(NUIDBQuery(field: NUIDBFieldQuery(name: field, type: type), type: condition, value: value));
    return this;
  }

  NUIDBQueryCombination innerAND(InnerLevelQuery query){
    NUIDBQueryCombination queryComb = NUIDBQueryCombination(queries: List(), operator: NUIDBQueryOperator.AND);
    query(queryComb);
    if(queryComb.queries.isNotEmpty) {
      queries.add(queryComb);
    }
    return this;
  }

  NUIDBQueryCombination innerOR(InnerLevelQuery query){
    NUIDBQueryCombination queryComb = NUIDBQueryCombination(queries: List(), operator: NUIDBQueryOperator.OR);
    query(queryComb);
    if(queryComb.queries.isNotEmpty) {
      queries.add(queryComb);
    }
    return this;
  }

}